<!DOCTYPE html>
<html>
<head>
  <meta charset="utf-8">
  <base data-ice="baseUrl" href="../../../../">
  <title data-ice="title">src/components/textfield/TextField.unit.js | formiojs</title>
  <link type="text/css" rel="stylesheet" href="css/style.css">
  <link type="text/css" rel="stylesheet" href="css/prettify-tomorrow.css">
  <script src="script/prettify/prettify.js"></script>
  <script src="script/manual.js"></script>
<meta name="description" content="JavaScript powered Forms with JSON Form Builder"><meta property="twitter:card" content="summary"><meta property="twitter:title" content="formiojs"><meta property="twitter:description" content="JavaScript powered Forms with JSON Form Builder"></head>
<body class="layout-container" data-ice="rootContainer">

<header>
  <a href="./">Home</a>
  
  <a href="identifiers.html">Reference</a>
  <a href="source.html">Source</a>
  
  <div class="search-box">
  <span>
    <img src="./image/search.png">
    <span class="search-input-edge"></span><input class="search-input"><span class="search-input-edge"></span>
  </span>
    <ul class="search-result"></ul>
  </div>
<a href="https://gitlab.com/atorico.com/formio/formio.js.git">Repository</a></header>

<nav class="navigation" data-ice="nav"><div>
  <ul>
    
  <li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/EventEmitter.js~EventEmitter.html">EventEmitter</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/Form.js~Form.html">Form</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/FormBuilder.js~FormBuilder.html">FormBuilder</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/PDFBuilder.js~PDFBuilder.html">PDFBuilder</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/WizardBuilder.js~WizardBuilder.html">WizardBuilder</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-embed">embed</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#builders">builders</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/builders/Builders.js~Builders.html">Builders</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components">components</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/Components.js~Components.html">Components</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components--classes-component">components/_classes/component</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Component">Component</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components--classes-component-editform">components/_classes/component/editForm</a><span data-ice="kind" class="kind-variable">V</span><span data-ice="name"><span><a href="variable/index.html#static-variable-EditFormUtils">EditFormUtils</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components--classes-componentmodal">components/_classes/componentModal</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/_classes/componentModal/ComponentModal.js~ComponentModal.html">ComponentModal</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components--classes-field">components/_classes/field</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/_classes/field/Field.js~Field.html">Field</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components--classes-nested">components/_classes/nested</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/_classes/nested/NestedComponent.js~NestedComponent.html">NestedComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-NestedComponent">NestedComponent</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-address">components/address</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Address">Address</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-button">components/button</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Button">Button</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-checkbox">components/checkbox</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/checkbox/Checkbox.js~CheckBoxComponent.html">CheckBoxComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Checkbox">Checkbox</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-columns">components/columns</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/columns/Columns.js~ColumnsComponent.html">ColumnsComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Columns">Columns</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-container">components/container</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/container/Container.js~ContainerComponent.html">ContainerComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Container">Container</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-content">components/content</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/content/Content.js~ContentComponent.html">ContentComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Content">Content</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-currency">components/currency</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/currency/Currency.js~CurrencyComponent.html">CurrencyComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Currency">Currency</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-datagrid">components/datagrid</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-DataGrid">DataGrid</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-datamap">components/datamap</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/datamap/DataMap.js~DataMapComponent.html">DataMapComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-DataMap">DataMap</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-datetime">components/datetime</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/datetime/DateTime.js~DateTimeComponent.html">DateTimeComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-DateTime">DateTime</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-day">components/day</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Day">Day</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-editgrid">components/editgrid</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-EditGrid">EditGrid</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-email">components/email</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/email/Email.js~EmailComponent.html">EmailComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Email">Email</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-fieldset">components/fieldset</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/fieldset/Fieldset.js~FieldsetComponent.html">FieldsetComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Fieldset">Fieldset</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-file">components/file</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-File">File</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-form">components/form</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Form">Form</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-hidden">components/hidden</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/hidden/Hidden.js~HiddenComponent.html">HiddenComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Hidden">Hidden</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-html">components/html</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/html/HTML.js~HTMLComponent.html">HTMLComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-HTML">HTML</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-number">components/number</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/number/Number.js~NumberComponent.html">NumberComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Number">Number</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-panel">components/panel</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Panel">Panel</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-password">components/password</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/password/Password.js~PasswordComponent.html">PasswordComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Password">Password</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-phonenumber">components/phonenumber</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/phonenumber/PhoneNumber.js~PhoneNumberComponent.html">PhoneNumberComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-PhoneNumber">PhoneNumber</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-radio">components/radio</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/radio/Radio.js~RadioComponent.html">RadioComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Radio">Radio</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-recaptcha">components/recaptcha</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/recaptcha/ReCaptcha.js~ReCaptchaComponent.html">ReCaptchaComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-ReCaptcha">ReCaptcha</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-resource">components/resource</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/resource/Resource.js~ResourceComponent.html">ResourceComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Resource">Resource</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-select">components/select</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Select">Select</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-select-fixtures">components/select/fixtures</a><span data-ice="kind" class="kind-variable">V</span><span data-ice="name"><span><a href="variable/index.html#static-variable-multiSelect">multiSelect</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-variable">V</span><span data-ice="name"><span><a href="variable/index.html#static-variable-multiSelectOptions">multiSelectOptions</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-selectboxes">components/selectboxes</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-SelectBoxes">SelectBoxes</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-signature">components/signature</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/signature/Signature.js~SignatureComponent.html">SignatureComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Signature">Signature</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-survey">components/survey</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Survey">Survey</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-table">components/table</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/table/Table.js~TableComponent.html">TableComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Table">Table</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-tabs">components/tabs</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/tabs/Tabs.js~TabsComponent.html">TabsComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Tabs">Tabs</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-tags">components/tags</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/tags/Tags.js~TagsComponent.html">TagsComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Tags">Tags</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-textarea">components/textarea</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-TextArea">TextArea</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-textfield">components/textfield</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-TextField">TextField</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-time">components/time</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/time/Time.js~TimeComponent.html">TimeComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Time">Time</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-tree">components/tree</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/tree/Node.js~Node.html">Node</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Tree">Tree</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-unknown">components/unknown</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/unknown/Unknown.js~UnknownComponent.html">UnknownComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Unknown">Unknown</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-url">components/url</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/url/Url.js~UrlComponent.html">UrlComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Url">Url</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-well">components/well</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/well/Well.js~WellComponent.html">WellComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Well">Well</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#contrib">contrib</a><span data-ice="kind" class="kind-variable">V</span><span data-ice="name"><span><a href="variable/index.html#static-variable-Contrib">Contrib</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#contrib-edittable">contrib/edittable</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/contrib/edittable/EditTable.js~EditTableComponent.html">EditTableComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-EditTable">EditTable</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#contrib-location">contrib/location</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/contrib/location/Location.js~LocationComponent.html">LocationComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Location">Location</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#contrib-modaledit">contrib/modaledit</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/contrib/modaledit/ModalEdit.js~ModalEditComponent.html">ModalEditComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-ModalEdit">ModalEdit</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#contrib-stripe-checkout">contrib/stripe/checkout</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/contrib/stripe/checkout/StripeCheckout.js~StripeCheckoutComponent.html">StripeCheckoutComponent</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#contrib-stripe-stripe">contrib/stripe/stripe</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/contrib/stripe/stripe/Stripe.js~StripeComponent.html">StripeComponent</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#displays">displays</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/displays/Displays.js~Displays.html">Displays</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#providers">providers</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/providers/Providers.js~Providers.html">Providers</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#providers-address">providers/address</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/providers/address/AddressProvider.js~AddressProvider.html">AddressProvider</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/providers/address/AzureAddressProvider.js~AzureAddressProvider.html">AzureAddressProvider</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/providers/address/CustomAddressProvider.js~CustomAddressProvider.html">CustomAddressProvider</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/providers/address/NominatimAddressProvider.js~NominatimAddressProvider.html">NominatimAddressProvider</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#providers-processor">providers/processor</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-fileProcessor">fileProcessor</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#providers-storage">providers/storage</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-azure">azure</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-base64">base64</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-dropbox">dropbox</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-indexeddb">indexeddb</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-s3">s3</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-getFormioUploadAdapterPlugin">getFormioUploadAdapterPlugin</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-url">url</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-setXhrHeaders">setXhrHeaders</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-variable">V</span><span data-ice="name"><span><a href="variable/index.html#static-variable-XHR">XHR</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#templates">templates</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/templates/Templates.js~Templates.html">Templates</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#templates-bootstrap">templates/bootstrap</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-iconClass">iconClass</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#utils">utils</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/utils/ChoicesWrapper.js~ChoicesWrapper.html">ChoicesWrapper</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-checkInvalidDate">checkInvalidDate</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-lessOrGreater">lessOrGreater</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-applyFormChanges">applyFormChanges</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-eachComponent">eachComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-escapeRegExCharacters">escapeRegExCharacters</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-findComponent">findComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-findComponents">findComponents</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-flattenComponents">flattenComponents</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-formatAsCurrency">formatAsCurrency</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-generateFormChange">generateFormChange</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-getComponent">getComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-getStrings">getStrings</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-getValue">getValue</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-hasCondition">hasCondition</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-isLayoutComponent">isLayoutComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-matchComponent">matchComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-parseFloatExt">parseFloatExt</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-removeComponent">removeComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-searchComponents">searchComponents</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-variable">V</span><span data-ice="name"><span><a href="variable/index.html#static-variable-KEY_CODES">KEY_CODES</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-variable">V</span><span data-ice="name"><span><a href="variable/index.html#static-variable-Evaluator">Evaluator</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-variable">V</span><span data-ice="name"><span><a href="variable/index.html#static-variable-CALENDAR_ERROR_MESSAGES">CALENDAR_ERROR_MESSAGES</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#utils-jsonlogic">utils/jsonlogic</a><span data-ice="kind" class="kind-variable">V</span><span data-ice="name"><span><a href="variable/index.html#static-variable-lodashOperators">lodashOperators</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#validator">validator</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/validator/Rules.js~Rules.html">Rules</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/validator/Validator.js~ValidationChecker.html">ValidationChecker</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#widgets">widgets</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/widgets/InputWidget.js~InputWidget.html">InputWidget</a></span></span></li>
</ul>
</div>
</nav>

<div class="content" data-ice="content"><h1 data-ice="title">src/components/textfield/TextField.unit.js</h1>
<pre class="source-code line-number raw-source-code"><code class="prettyprint linenums" data-ice="content">import assert from &apos;power-assert&apos;;
import _ from &apos;lodash&apos;;
import Harness from &apos;../../../test/harness&apos;;
import TextFieldComponent from &apos;./TextField&apos;;
import Formio from &apos;./../../Formio&apos;;
import &apos;flatpickr&apos;;

import {
  comp1,
  comp2,
  comp4,
  comp5,
  comp6
} from &apos;./fixtures&apos;;

describe(&apos;TextField Component&apos;, () =&gt; {
  it(&apos;Should create a new TextField&apos;, () =&gt; {
    const textField = new TextFieldComponent({
      label: &apos;First Name&apos;,
      key: &apos;firstName&apos;,
      input: true,
      type: &apos;textfield&apos;
    });

    assert.equal(textField.component.key, &apos;firstName&apos;);
  });

  it(&apos;Should build a TextField component&apos;, () =&gt; {
    return Harness.testCreate(TextFieldComponent, comp1).then((component) =&gt; {
      Harness.testElements(component, &apos;input[type=&quot;text&quot;]&apos;, 1);
    });
  });

  it(&apos;Should disable multiple mask selector if component is disabled&apos;, (done) =&gt; {
    Harness.testCreate(TextFieldComponent, comp4).then((component) =&gt; {
      Harness.testElements(component, &apos;[disabled]&apos;, 2);
      done();
    });
  });

  it(&apos;Should provide required validation&apos;, () =&gt; {
    return Harness.testCreate(TextFieldComponent, _.merge({}, comp2, {
      validate: { required: true }
    })).then((component) =&gt; {
      return Harness.testInvalid(component, &apos;&apos;, &apos;firstName&apos;, &apos;First Name is required&apos;).then(() =&gt; component);
    }).then((component) =&gt; {
      return Harness.testValid(component, &apos;te&apos;).then(() =&gt; component);
    });
  });

  it(&apos;Should provide minWords validation&apos;, () =&gt; {
    return Harness.testCreate(TextFieldComponent, _.merge({}, comp2, {
      validate: { minWords: 2 }
    })).then((component) =&gt; {
      return Harness.testInvalid(component, &apos;test&apos;, &apos;firstName&apos;, &apos;First Name must have at least 2 words.&apos;).then(() =&gt; component);
    }).then((component) =&gt; {
      return Harness.testValid(component, &apos;te st&apos;).then(() =&gt; component);
    });
  });

  it(&apos;Should correctly calculate remaining words&apos;, (done) =&gt; {
    Harness.testCreate(TextFieldComponent, comp5).then((component) =&gt; {
      const inputEvent = new Event(&apos;input&apos;, { bubbles: true, cancelable: true });
      const element = component.refs.input[0];

      element.value = &apos;paper format A4&apos;;
      element.dispatchEvent(inputEvent);

      setTimeout(()=&gt;{
        assert.equal(component.refs.wordcount[0].textContent, &apos;2 words remaining.&apos;);

        element.value = &apos;Hey, guys! We are here!!&apos;;
        element.dispatchEvent(inputEvent);

        setTimeout(()=&gt;{
          assert.equal(component.refs.wordcount[0].textContent, &apos;0 words remaining.&apos;);

          element.value = &apos; Some   test   text  111 &apos;;
          element.dispatchEvent(inputEvent);

          setTimeout(()=&gt;{
            assert.equal(component.refs.wordcount[0].textContent, &apos;1 words remaining.&apos;);

            done();
          }, 300);
        }, 275);
      }, 250);
    });
  });

  it(&apos;Should provide maxWords validation&apos;, () =&gt; {
    return Harness.testCreate(TextFieldComponent, _.merge({}, comp2, {
      validate: { maxWords: 2 }
    })).then((component) =&gt; {
      return Harness.testInvalid(component, &apos;test test test&apos;, &apos;firstName&apos;, &apos;First Name must have no more than 2 words.&apos;).then(() =&gt; component);
    }).then((component) =&gt; {
      return Harness.testValid(component, &apos;te st&apos;).then(() =&gt; component);
    });
  });

  it(&apos;Should provide minLength validation&apos;, () =&gt; {
    return Harness.testCreate(TextFieldComponent, _.merge({}, comp2, {
      validate: { minLength: 2 }
    })).then((component) =&gt; {
      return Harness.testInvalid(component, &apos;t&apos;, &apos;firstName&apos;, &apos;First Name must have at least 2 characters.&apos;).then(() =&gt; component);
    }).then((component) =&gt; {
      return Harness.testValid(component, &apos;te&apos;).then(() =&gt; component);
    });
  });

  it(&apos;Should provide maxLength validation&apos;, () =&gt; {
    return Harness.testCreate(TextFieldComponent, _.merge({}, comp2, {
      validate: { maxLength: 5 }
    })).then(component =&gt; {
      return Harness.testInvalid(component, &apos;testte&apos;, &apos;firstName&apos;, &apos;First Name must have no more than 5 characters.&apos;).then(() =&gt; component);
    }).then((component) =&gt; {
      return Harness.testValid(component, &apos;te&apos;).then(() =&gt; component);
    });
  });

  it(&apos;Should provide custom validation&apos;, () =&gt; {
    return Harness.testCreate(TextFieldComponent, _.merge({}, comp2, {
      validate: {
        custom: &apos;valid = (input !== &quot;Joe&quot;) ? true : &quot;You cannot be Joe&quot;&apos;
      }
    })).then((component) =&gt; {
      return Harness.testInvalid(component, &apos;Joe&apos;, &apos;firstName&apos;, &apos;You cannot be Joe&apos;).then(() =&gt; component);
    }).then((component) =&gt; {
      return Harness.testValid(component, &apos;Tom&apos;).then(() =&gt; component);
    });
  });

  it(&apos;Should provide one custom error message&apos;, (done) =&gt; {
    const formJson =  {
      components: [{
          label: &apos;Text Field&apos;,
          tableView: true,
          validate: {
            pattern: &apos;^[0-9]*$]&apos;,
            customMessage: &apos;Custom Error Message&apos;,
            minWords: 10
          },
          key: &apos;textField&apos;,
          type: &apos;textfield&apos;,
          input: true
       }]
    };
    const element = document.createElement(&apos;div&apos;);
    Formio.createForm(element, formJson)
      .then(form =&gt; {
        form.submission = {
          data: {
            textField: &apos;textField&apos;
          }
        };
        const textField = form.getComponent(&apos;textField&apos;);
        setTimeout(() =&gt; {
          assert.equal(textField.refs.messageContainer.children.length, 1);
          assert.equal(textField.refs.messageContainer.children[0].innerHTML, &apos;Custom Error Message&apos;);
          done();
        }, 300);
      })
      .catch(done);
  });

  it(&apos;Should provide json validation&apos;, () =&gt; {
    return Harness.testCreate(TextFieldComponent, _.merge({}, comp2, {
      validate: {
        json: {
          &apos;if&apos;: [
            {
              &apos;===&apos;: [
                { var: &apos;data.firstName&apos; },
                &apos;Joe&apos;
              ]
            },
            true,
            &apos;You must be Joe&apos;
          ]
        }
      }
    })).then((component) =&gt; {
      return Harness.testInvalid(component, &apos;Tom&apos;, &apos;firstName&apos;, &apos;You must be Joe&apos;).then(() =&gt; component);
    }).then((component) =&gt; {
      return Harness.testValid(component, &apos;Joe&apos;).then(() =&gt; component);
    });
  });

  it(&apos;Should provide validation of number input mask after setting value&apos;, (done) =&gt; {
    const form = _.cloneDeep(comp6);
    form.components[0].inputMask = &apos;99/99-99.99:99,99&apos;;

    const validValues = [
      &apos;&apos;,
      &apos;99/99-99.99:99,99&apos;,
    ];

    const invalidValues = [
      &apos;99/99-99.99:99,,99&apos;,
      &apos;99/99-99.99:99,9&apos;,
      &apos;9999-99.99:99,,99&apos;,
      &apos;99/99-99.99:9(9,9)9&apos;,
      &apos;99999999#999999999&apos;,
      &apos;fffffff()f99/99-99.99:99,99&apos;,
      &apos;77ff7777ff7777ff7777&apos;,
      &apos;9/99-99.99999,99&apos;,
      &apos;9/99-9/9.9/9:99,9/9&apos;,
      &apos;99/99-a9.99:99,99&apos;,
      &apos;99/99---.99:99,99&apos;,
      &apos;ddddddddddddddd&apos;,
      &apos;9/99-9/9.9/9:99,9/9ddd&apos;,
      &apos;9/99-99.99999,fffffff&apos;,
      &apos;99/_9-99.9f9:99,9g9&apos;,
      &apos;A8/99-99.99:99,99&apos;,
    ];

    const testValidity = (values, valid, lastValue) =&gt; {
      _.each(values, (value) =&gt; {
        const element = document.createElement(&apos;div&apos;);

        Formio.createForm(element, form).then(form =&gt; {
          form.setPristine(false);

          const component = form.getComponent(&apos;textField&apos;);
          const changed = component.setValue(value);
          const error = &apos;Text Field does not match the mask.&apos;;

          if (value) {
            assert.equal(changed, true, &apos;Should set value&apos;);
          }

          setTimeout(() =&gt; {
            if (valid) {
              assert.equal(!!component.error, false, &apos;Should not contain error&apos;);
            }
            else {
              assert.equal(!!component.error, true, &apos;Should contain error&apos;);
              assert.equal(component.error.message, error, &apos;Should contain error message&apos;);
              assert.equal(component.element.classList.contains(&apos;has-error&apos;), true, &apos;Should contain error class&apos;);
              assert.equal(component.refs.messageContainer.textContent.trim(), error, &apos;Should show error&apos;);
            }

            if (_.isEqual(value, lastValue)) {
              done();
            }
          }, 300);
        }).catch(done);
      });
    };

    testValidity(validValues, true);
    testValidity(invalidValues, false, invalidValues[invalidValues.length-1]);
  });

  it(&apos;Should allow inputing only numbers and format input according to input mask&apos;, (done) =&gt; {
    const form = _.cloneDeep(comp6);
    form.components[0].inputMask = &apos;99/99-99.99:99,99&apos;;

    const values = [
      &apos;99/99-99.99:99,,99&apos;,
      &apos;9999-99.99:999,,99&apos;,
      &apos;99/99-99.99:9(9,9)9&apos;,
      &apos;99999999999999999&apos;,
      &apos;ffffffff99/99-99.99:99,99&apos;,
      &apos;99ff999999ff999ff9&apos;,
      &apos;9/99-99.99999,999&apos;,
      &apos;9/99-9/9.9/9:999,9/9&apos;,
      &apos;99.99-a9.99:999,99&apos;,
      &apos;99/99---.99:9999,99&apos;,
      &apos;999999999999&apos;,
      &apos;99999-9/9.9/9:99,9/9ddd&apos;,
      &apos;9----99999-99.99999,fffffff&apos;,
      &apos;999-9kkkk9.99999f9:99,9g9&apos;,
      &apos;A9/99-99.999:99,99&apos;,
    ];

    const testFormatting = (values, lastValue) =&gt; {
      _.each(values, (value) =&gt; {
        const element = document.createElement(&apos;div&apos;);

        Formio.createForm(element, form).then(form =&gt; {
          form.setPristine(false);

          const component = form.getComponent(&apos;textField&apos;);
          const input = component.refs.input[0];
          const inputEvent = new Event(&apos;input&apos;);
          input.value = value;
          input.dispatchEvent(inputEvent);

          setTimeout(() =&gt; {
            assert.equal(!!component.error, false, &apos;Should not contain error&apos;);
            assert.equal(component.getValue(), &apos;99/99-99.99:99,99&apos;, &apos;Should set and format value&apos;);

            if (_.isEqual(value, lastValue)) {
              done();
            }
          }, 300);
        }).catch(done);
      });
    };

    testFormatting(values, values[values.length-1]);
  });

  it(&apos;Should provide validation for alphabetic input mask after setting value&apos;, (done) =&gt; {
    const form = _.cloneDeep(comp6);
    form.components[0].inputMask = &apos;a/A/a-a:a.a,aa&apos;;

    const validValues = [
      &apos;&apos;,
      &apos;b/V/r-y:d.d,as&apos;,
      &apos;b/b/r-y:d.d,as&apos;,
    ];

    const invalidValues = [
      &apos;b/b/r-y:d.d&apos;,
      &apos;b/v/r-yCC:d.d,as&apos;,
      &apos;rD/F/R-y:d.d,DE&apos;,
      &apos;bv/Sr-y:d.d,as&apos;,
      &apos;555555555555555&apos;,
      &apos;ssssEsssssssssssss&apos;,
      &apos;b/v/Rr-y:d$.d,a&apos;,
      &apos;3/3/#r-y:d.d,as&apos;,
      &apos;3/3/6-6&amp;&amp;:d...d,as&apos;,
      &apos;5/5/5ee-55.5,5&apos;
    ];

    const testValidity = (values, valid, lastValue) =&gt; {
      _.each(values, (value) =&gt; {
        const element = document.createElement(&apos;div&apos;);

        Formio.createForm(element, form).then(form =&gt; {
          form.setPristine(false);

          const component = form.getComponent(&apos;textField&apos;);
          const changed = component.setValue(value);
          const error = &apos;Text Field does not match the mask.&apos;;

          if (value) {
            assert.equal(changed, true, &apos;Should set value&apos;);
          }

          setTimeout(() =&gt; {
            if (valid) {
              assert.equal(!!component.error, false, &apos;Should not contain error&apos;);
            }
            else {
              assert.equal(!!component.error, true, &apos;Should contain error&apos;);
              assert.equal(component.error.message, error, &apos;Should contain error message&apos;);
              assert.equal(component.element.classList.contains(&apos;has-error&apos;), true, &apos;Should contain error class&apos;);
              assert.equal(component.refs.messageContainer.textContent.trim(), error, &apos;Should show error&apos;);
            }

            if (_.isEqual(value, lastValue)) {
              done();
            }
          }, 300);
        }).catch(done);
      });
    };

    testValidity(validValues, true);
    testValidity(invalidValues, false, invalidValues[invalidValues.length-1]);
  });

  it(&apos;Should allow inputing only letters and format input according to input mask&apos;, (done) =&gt; {
    const form = _.cloneDeep(comp6);
    form.components[0].inputMask = &apos;a/a/a-a:a.a,aa&apos;;

    const values = [
        &apos;ssssSSSSSSS/sss-ss.s,ss&apos;,
        &apos;ss/sSss-sSSs.s,ss&apos;,
        &apos;ssSssssssSSSssssss&apos;,
        &apos;s/sS/sss-s5555:sss.--s,s&apos;,
        &apos;3/s3/Ss-s:ss.s,ssSsss&apos;,
        &apos;ssSs3/3s/s6-s6:s...s,s&apos;,
        &apos;s5/5sSS/5s-5:sS---5.s5,s5sss&apos;
    ];

    const testFormatting = (values, lastValue) =&gt; {
      _.each(values, (value) =&gt; {
        const element = document.createElement(&apos;div&apos;);

        Formio.createForm(element, form).then(form =&gt; {
          form.setPristine(false);

          const component = form.getComponent(&apos;textField&apos;);
          const input = component.refs.input[0];
          const inputEvent = new Event(&apos;input&apos;);
          input.value = value;
          input.dispatchEvent(inputEvent);

          setTimeout(() =&gt; {
            assert.equal(!!component.error, false, &apos;Should not contain error&apos;);
            assert.equal(component.getValue(), &apos;s/s/s-s:s.s,ss&apos;, &apos;Should set and format value&apos;);

            if (_.isEqual(value, lastValue)) {
              done();
            }
          }, 300);
        }).catch(done);
      });
    };

    testFormatting(values, values[values.length-1]);
  });

  it(&apos;Should provide validation for alphanumeric input mask after setting value&apos;, (done) =&gt; {
    const form = _.cloneDeep(comp6);
    form.components[0].inputMask = &apos;**/***.*-*,**&apos;;

    const validValues = [
      &apos;&apos;,
      &apos;f4/D34.3-S,dd&apos;,
      &apos;gg/ggg.g-g,gg&apos;,
      &apos;DD/DDD.D-D,DD&apos;,
      &apos;55/555.5-5,55&apos;,
    ];

    const invalidValues = [
      &apos;er432ff&apos;,
      &apos;rD5/F/R-y:d&apos;,
      &apos;_=+dsds4&apos;,
      &apos;sFFFFF--------2&apos;,
      &apos;sd&apos;,
      &apos;sf__df&apos;,
      &apos;gg/ggg.g-g&apos;,
    ];

    const testValidity = (values, valid, lastValue) =&gt; {
      _.each(values, (value) =&gt; {
        const element = document.createElement(&apos;div&apos;);

        Formio.createForm(element, form).then(form =&gt; {
          form.setPristine(false);

          const component = form.getComponent(&apos;textField&apos;);
          const changed = component.setValue(value);
          const error = &apos;Text Field does not match the mask.&apos;;

          if (value) {
            assert.equal(changed, true, &apos;Should set value&apos;);
          }

          setTimeout(() =&gt; {
            if (valid) {
              assert.equal(!!component.error, false, &apos;Should not contain error&apos;);
            }
            else {
              assert.equal(!!component.error, true, &apos;Should contain error&apos;);
              assert.equal(component.error.message, error, &apos;Should contain error message&apos;);
              assert.equal(component.element.classList.contains(&apos;has-error&apos;), true, &apos;Should contain error class&apos;);
              assert.equal(component.refs.messageContainer.textContent.trim(), error, &apos;Should show error&apos;);
            }

            if (_.isEqual(value, lastValue)) {
              done();
            }
          }, 300);
        }).catch(done);
      });
    };

    testValidity(validValues, true);
    testValidity(invalidValues, false, invalidValues[invalidValues.length-1]);
  });

  it(&apos;Should allow inputing only letters and digits and format input according to input mask&apos;, (done) =&gt; {
    const form = _.cloneDeep(comp6);
    form.components[0].inputMask = &apos;**/***.*-*,**&apos;;

    const values = [
      { value:&apos;ssssSSSSSSS/sss-ss.s,ss&apos;, expected: &apos;ss/ssS.S-S,SS&apos; },
      { value:&apos;ss/sSss-sSSs.s,ss&apos;, expected: &apos;ss/sSs.s-s,SS&apos; },
      { value:&apos;ssS666ssssssSSSssssss&apos;, expected: &apos;ss/S66.6-s,ss&apos; },
      { value:&apos;s/sS/sss-s5555:sss.--s,s&apos;, expected: &apos;ss/Sss.s-s,55&apos; },
      { value:&apos;3/s3/Ss-s:ss.s,ssSsss&apos;, expected: &apos;3s/3Ss.s-s,ss&apos; },
      { value:&apos;ssSs3/3s/s6-s6:s...s,s&apos;, expected: &apos;ss/Ss3.3-s,s6&apos; },
      { value:&apos;s5/5sSS/5s-5:sS---5.s5,s5sss&apos;, expected: &apos;s5/5sS.S-5,s5&apos; },
    ];

    const testFormatting = (values, lastValue) =&gt; {
      _.each(values, (value) =&gt; {
        const element = document.createElement(&apos;div&apos;);

        Formio.createForm(element, form).then(form =&gt; {
          form.setPristine(false);

          const component = form.getComponent(&apos;textField&apos;);
          const input = component.refs.input[0];
          const inputEvent = new Event(&apos;input&apos;);
          input.value = value.value;
          input.dispatchEvent(inputEvent);

          setTimeout(() =&gt; {
            assert.equal(!!component.error, false, &apos;Should not contain error&apos;);
            assert.equal(component.getValue(), value.expected, &apos;Should set and format value&apos;);

            if (_.isEqual(value.value, lastValue)) {
              done();
            }
          }, 300);
        }).catch(done);
      });
    };

    testFormatting(values, values[values.length-1].value);
  });

  it(&apos;Should provide validation for mixed input mask after setting value&apos;, (done) =&gt; {
    const form = _.cloneDeep(comp6);
    form.components[0].inputMask = &apos;**/99-aa&apos;;

    const validValues = [
      &apos;&apos;,
      &apos;4r/34-fg&apos;,
      &apos;46/34-yy&apos;,
      &apos;ye/56-op&apos;,
      &apos;We/56-op&apos;,
    ];

    const invalidValues = [
      &apos;te/56-Dp&apos;,
      &apos;te/E6-pp&apos;,
      &apos;tdddde/E6-pp&apos;,
      &apos;te/E6&apos;,
      &apos;te/E6-p&apos;,
      &apos;gdfgdfgdf&apos;,
      &apos;43543&apos;,
      &apos;W&apos;
    ];

    const testValidity = (values, valid, lastValue) =&gt; {
      _.each(values, (value) =&gt; {
        const element = document.createElement(&apos;div&apos;);

        Formio.createForm(element, form).then(form =&gt; {
          form.setPristine(false);

          const component = form.getComponent(&apos;textField&apos;);
          const changed = component.setValue(value);
          const error = &apos;Text Field does not match the mask.&apos;;

          if (value) {
            assert.equal(changed, true, &apos;Should set value&apos;);
          }

          setTimeout(() =&gt; {
            if (valid) {
              assert.equal(!!component.error, false, &apos;Should not contain error&apos;);
            }
            else {
              assert.equal(!!component.error, true, &apos;Should contain error&apos;);
              assert.equal(component.error.message, error, &apos;Should contain error message&apos;);
              assert.equal(component.element.classList.contains(&apos;has-error&apos;), true, &apos;Should contain error class&apos;);
              assert.equal(component.refs.messageContainer.textContent.trim(), error, &apos;Should show error&apos;);
            }

            if (_.isEqual(value, lastValue)) {
              done();
            }
          }, 300);
        }).catch(done);
      });
    };

    testValidity(validValues, true);
    testValidity(invalidValues, false, invalidValues[invalidValues.length-1]);
  });

  it(&apos;Should allow inputing only letters and digits and format input according to mixed input mask&apos;, (done) =&gt; {
    const form = _.cloneDeep(comp6);
    form.components[0].inputMask = &apos;**/99-aa&apos;;

    const values = [
      { value:&apos;S67gf-+f34cfd&apos;, expected: &apos;S6/73-cf&apos; },
      { value:&apos;56DDDfdsf23,DDdsf&apos;, expected: &apos;56/23-ds&apos; },
      { value:&apos;--fs344d.g234df&apos;, expected: &apos;fs/34-dg&apos; },
      { value:&apos;000000000g234df&apos;, expected: &apos;00/00-gd&apos; },
    ];

    const testFormatting = (values, lastValue) =&gt; {
      _.each(values, (value) =&gt; {
        const element = document.createElement(&apos;div&apos;);

        Formio.createForm(element, form).then(form =&gt; {
          form.setPristine(false);

          const component = form.getComponent(&apos;textField&apos;);
          const input = component.refs.input[0];
          const inputEvent = new Event(&apos;input&apos;);
          input.value = value.value;
          input.dispatchEvent(inputEvent);

          setTimeout(() =&gt; {
            assert.equal(!!component.error, false, &apos;Should not contain error&apos;);
            assert.equal(component.getValue(), value.expected, &apos;Should set and format value&apos;);

            if (_.isEqual(value.value, lastValue)) {
              done();
            }
          }, 300);
        }).catch(done);
      });
    };

    testFormatting(values, values[values.length-1].value);
  });

  it(&apos;Should allow multiple masks&apos;, (done) =&gt; {
    const form = _.cloneDeep(comp6);
    const tf = form.components[0];
    tf.allowMultipleMasks = true;
    tf.inputMasks = [
      { label: &apos;number&apos;, mask: &apos;99-99&apos; },
      { label: &apos;letter&apos;, mask: &apos;aa.aa&apos; },
      { label: &apos;any&apos;, mask: &apos;**/**&apos; }
    ];

    const masks = [
      { index: 0, mask: &apos;number&apos;, valueValid:[&apos;33-33&apos;], valueInvalid: [&apos;Bd&apos;] },
      { index: 1, mask: &apos;letter&apos;, valueValid:[&apos;rr.dd&apos;], valueInvalid: [&apos;Nr-22&apos;] },
      { index: 2, mask: &apos;any&apos;, valueValid:[&apos;Dv/33&apos;], valueInvalid: [&apos;4/4&apos;] },
    ];

    const testMask = (mask, valid, lastValue) =&gt; {
      const values = valid ? mask.valueValid : mask.valueInvalid;

      _.each(values, (value) =&gt; {
        const element = document.createElement(&apos;div&apos;);

        Formio.createForm(element, form).then(form =&gt; {
          form.setPristine(false);
          const component = form.getComponent(&apos;textField&apos;);
          const changed = component.setValue({ value: value, maskName: mask.mask });
          const error = &apos;Text Field does not match the mask.&apos;;

          if (value) {
            assert.equal(changed, true, &apos;Should set value&apos;);
          }

          setTimeout(() =&gt; {
            assert.equal(component.refs.select[0].options[mask.index].selected, true, &apos;Should select correct mask&apos;);
            assert.equal(component.getValue().maskName, mask.mask, &apos;Should apply correct mask&apos;);

            if (valid) {
              assert.equal(!!component.error, false, &apos;Should not contain error&apos;);
            }
            else {
              assert.equal(!!component.error, true, &apos;Should contain error&apos;);
              assert.equal(component.error.message, error, &apos;Should contain error message&apos;);
              assert.equal(component.element.classList.contains(&apos;has-error&apos;), true, &apos;Should contain error class&apos;);
              assert.equal(component.refs.messageContainer.textContent.trim(), error, &apos;Should show error&apos;);
            }

            if (_.isEqual(value, lastValue)) {
              done();
            }
          }, 300);
        }).catch(done);
      });
    };

    _.each(masks, (mask, index) =&gt; {
      testMask(mask, true);
      testMask(mask, false,  (index === masks.length - 1) ? mask.valueInvalid[mask.valueInvalid.length-1] : undefined);
    });
  });

  it(&apos;Should provide validation of number input mask with low dash and placeholder char after setting value&apos;, (done) =&gt; {
    const form = _.cloneDeep(comp6);
    form.components[0].inputMask = &apos;99_99/99&apos;;
    form.components[0].inputMaskPlaceholderChar = &apos;.&apos;;

    const validValues = [
      &apos;&apos;,
      &apos;55_44/88&apos;,
    ];

    const invalidValues = [
      &apos;99 99 99&apos;,
      &apos;44_44_55&apos;,
      &apos;55555555&apos;,
    ];

    const testValidity = (values, valid, lastValue) =&gt; {
      _.each(values, (value) =&gt; {
        const element = document.createElement(&apos;div&apos;);

        Formio.createForm(element, form).then(form =&gt; {
          form.setPristine(false);

          const component = form.getComponent(&apos;textField&apos;);
          const input = component.refs.input[0];

          assert.equal(input.placeholder, &apos;.._../..&apos;, &apos;Should set placeholder using the char setting&apos;);

          const changed = component.setValue(value);
          const error = &apos;Text Field does not match the mask.&apos;;

          if (value) {
            assert.equal(changed, true, &apos;Should set value&apos;);
          }

          setTimeout(() =&gt; {
            if (valid) {
              assert.equal(!!component.error, false, &apos;Should not contain error&apos;);
            }
            else {
              assert.equal(!!component.error, true, &apos;Should contain error&apos;);
              assert.equal(component.error.message, error, &apos;Should contain error message&apos;);
              assert.equal(component.element.classList.contains(&apos;has-error&apos;), true, &apos;Should contain error class&apos;);
              assert.equal(component.refs.messageContainer.textContent.trim(), error, &apos;Should show error&apos;);
            }

            if (_.isEqual(value, lastValue)) {
              done();
            }
          }, 300);
        }).catch(done);
      });
    };

    testValidity(validValues, true);
    testValidity(invalidValues, false, invalidValues[invalidValues.length-1]);
  });

  it(&apos;Should format input according to input mask with low dash when placeholder char is set&apos;, (done) =&gt; {
    const form = _.cloneDeep(comp6);
    form.components[0].inputMask = &apos;99_99/99&apos;;
    form.components[0].inputMaskPlaceholderChar = &apos;.&apos;;

    const values = [
      { value:&apos;4444444&apos;, expected: &apos;44_44/44&apos; },
    ];

    const testFormatting = (values, lastValue) =&gt; {
      _.each(values, (value) =&gt; {
        const element = document.createElement(&apos;div&apos;);

        Formio.createForm(element, form).then(form =&gt; {
          form.setPristine(false);

          const component = form.getComponent(&apos;textField&apos;);
          const input = component.refs.input[0];
          const inputEvent = new Event(&apos;input&apos;);
          input.value = value.value;
          input.dispatchEvent(inputEvent);

          setTimeout(() =&gt; {
            assert.equal(!!component.error, false, &apos;Should not contain error&apos;);
            assert.equal(component.getValue(), value.expected, &apos;Should set and format value&apos;);

            if (_.isEqual(value.value, lastValue)) {
              done();
            }
          }, 300);
        }).catch(done);
      });
    };

    testFormatting(values, values[values.length-1].value);
  });

  it(&apos;Should correctly count characters if character counter is enabled&apos;, (done) =&gt; {
    const form = _.cloneDeep(comp6);
    form.components[0].showCharCount = true;
    const element = document.createElement(&apos;div&apos;);

    Formio.createForm(element, form).then(form =&gt; {
      const component = form.getComponent(&apos;textField&apos;);
      const inputValue = (value) =&gt; {
        const input = component.refs.input[0];
        const inputEvent = new Event(&apos;input&apos;);
        input.value = value;
        input.dispatchEvent(inputEvent);
      };

      const checkValue = (value) =&gt; {
        assert.equal(component.dataValue, value, &apos;Should set value&apos;);
        assert.equal(parseInt(component.refs.charcount[0].textContent), value.length, &apos;Should show correct chars number&apos;);
        assert.equal(component.refs.charcount[0].textContent, `${value.length} characters`, &apos;Should show correct message&apos;);
      };

      let value = &apos;test Value (@#!-&quot;]) _ 23.,5}/*&amp;&amp;&apos;;
      inputValue(value);
      setTimeout(() =&gt; {
        checkValue(value);
        value = &apos;&apos;;
        inputValue(value);

        setTimeout(() =&gt; {
          checkValue(value);
          value = &apos;  &apos;;
          inputValue(value);

          setTimeout(() =&gt; {
            checkValue(value);

            done();
          }, 200);
        }, 200);
      }, 200);
    }).catch(done);
  });

  it(&apos;Should format value to uppercase&apos;, (done) =&gt; {
    const form = _.cloneDeep(comp6);
    form.components[0].case = &apos;uppercase&apos;;
    const element = document.createElement(&apos;div&apos;);

    Formio.createForm(element, form).then(form =&gt; {
      const component = form.getComponent(&apos;textField&apos;);
      const inputValue = (value) =&gt; {
        const input = component.refs.input[0];
        const inputEvent = new Event(&apos;input&apos;);
        input.value = value;
        input.dispatchEvent(inputEvent);
      };

      const checkValue = (value) =&gt; {
        assert.equal(component.dataValue, value.toUpperCase(), &apos;Should format value to uppercase&apos;);
        assert.equal(component.getValue(), value.toUpperCase(), &apos;Should format value to uppercase&apos;);
      };

      let value = &apos;SoMe Value&apos;;
      inputValue(value);
      setTimeout(() =&gt; {
        checkValue(value);
        value = &apos;test 1 value 1&apos;;
        inputValue(value);

        setTimeout(() =&gt; {
          checkValue(value);
          value = &apos;&apos;;
          inputValue(value);

          setTimeout(() =&gt; {
            checkValue(value);

            done();
          }, 100);
        }, 100);
      }, 100);
    }).catch(done);
  });

  it(&apos;Should format value to lowercase&apos;, (done) =&gt; {
    const form = _.cloneDeep(comp6);
    form.components[0].case = &apos;lowercase&apos;;
    const element = document.createElement(&apos;div&apos;);

    Formio.createForm(element, form).then(form =&gt; {
      const component = form.getComponent(&apos;textField&apos;);
      const inputValue = (value) =&gt; {
        const input = component.refs.input[0];
        const inputEvent = new Event(&apos;input&apos;);
        input.value = value;
        input.dispatchEvent(inputEvent);
      };

      const checkValue = (value) =&gt; {
        assert.equal(component.dataValue, value.toLowerCase(), &apos;Should format value to lowercase (1)&apos;);
        assert.equal(component.getValue(), value.toLowerCase(), &apos;Should format value to lowercase (2)&apos;);
      };

      let value = &apos;SoMe Value&apos;;
      inputValue(value);
      setTimeout(() =&gt; {
        checkValue(value);
        value = &apos;TEST 1 VALUE (1)&apos;;
        inputValue(value);

        setTimeout(() =&gt; {
          checkValue(value);
          value = &apos;&apos;;
          inputValue(value);

          setTimeout(() =&gt; {
            checkValue(value);

            done();
          }, 100);
        }, 100);
      }, 100);
    }).catch(done);
  });

  it(&apos;Should render and open/close calendar on click&apos;, (done) =&gt; {
    const form = _.cloneDeep(comp6);
    form.components[0].widget = {
      allowInput: true,
      altInput: true,
      clickOpens: true,
      dateFormat: &apos;dd-MM-yyyy&apos;,
      enableDate: true,
      enableTime: true,
      format: &apos;dd-MM-yyyy&apos;,
      hourIncrement: 1,
      minuteIncrement: 5,
      mode: &apos;single&apos;,
      noCalendar: false,
      saveAs: &apos;date&apos;,
      &apos;time_24hr&apos;: false,
      type: &apos;calendar&apos;,
      useLocaleSettings: false,
    };
    const element = document.createElement(&apos;div&apos;);

    Formio.createForm(element, form).then(form =&gt; {
      const component = form.getComponent(&apos;textField&apos;);
      const clickElem = (path) =&gt; {
        const elem = _.get(component, path);
        const clickEvent = new Event(&apos;click&apos;);
        elem.dispatchEvent(clickEvent);
      };
      const checkCalendarState = (open) =&gt; {
        const calendar = document.querySelector(&apos;.flatpickr-calendar&apos;);
        assert.equal(calendar.classList.contains(&apos;open&apos;), open, `${open ? &apos;Should open calendar&apos; : &apos;Should close calendar&apos;}`);
      };

      assert.equal(component.widget.settings.type, &apos;calendar&apos;, &apos;Should create calendar widget&apos;);
      clickElem(&apos;refs.suffix[0]&apos;);

       setTimeout(() =&gt; {
        checkCalendarState(true);
        clickElem(&apos;refs.suffix[0]&apos;);

        setTimeout(() =&gt; {
          checkCalendarState(false);
          clickElem(&apos;element.children[1].children[0].children[1]&apos;);

          setTimeout(() =&gt; {
            checkCalendarState(true);
            clickElem(&apos;refs.suffix[0]&apos;);

            setTimeout(() =&gt; {
              checkCalendarState(false);
              document.body.innerHTML = &apos;&apos;;
              done();
            }, 300);
          }, 300);
        }, 300);
      }, 300);
    }).catch(done);
  });

  it(&apos;Should set value into calendar&apos;, (done) =&gt; {
    const form = _.cloneDeep(comp6);
    form.components[0].widget = {
      allowInput: true,
      altInput: true,
      clickOpens: true,
      dateFormat: &apos;dd-MM-yyyy&apos;,
      enableDate: true,
      enableTime: true,
      format: &apos;dd-MM-yyyy&apos;,
      hourIncrement: 1,
      minuteIncrement: 5,
      mode: &apos;single&apos;,
      noCalendar: false,
      saveAs: &apos;date&apos;,
     &apos;time_24hr&apos;: false,
      type: &apos;calendar&apos;,
      useLocaleSettings: false,
    };
    const element = document.createElement(&apos;div&apos;);

    Formio.createForm(element, form).then(form =&gt; {
      const component = form.getComponent(&apos;textField&apos;);
      const clickElem = (path) =&gt; {
        const elem = _.get(component, path);
        const clickEvent = new Event(&apos;click&apos;);
        elem.dispatchEvent(clickEvent);
      };
      const checkCalendarState = (open, selectedDay) =&gt; {
        const calendar = document.querySelector(&apos;.flatpickr-calendar&apos;);
        assert.equal(calendar.classList.contains(&apos;open&apos;), open, `${open ? &apos;Should open calendar&apos; : &apos;Should close calendar&apos;}`);
        if (selectedDay) {
          const day = calendar.querySelector(&apos;.flatpickr-day.selected&apos;).textContent;
          assert.equal(day, selectedDay, &apos;Should select correct day&apos;);
        }
      };

      const date = &apos;16-03-2031&apos;;

      component.setValue(date);

       setTimeout(() =&gt; {
        checkCalendarState(false);
        const widget = component.element.querySelector(&apos;.flatpickr-input&apos;).widget;

        assert.equal(component.getValue(), date, &apos;Should set text field value&apos;);
        assert.equal(widget.calendar.input.value, date, &apos;Should set flatpickr value&apos;);
        assert.equal(widget.calendar.currentMonth, 2, &apos;Should set correct month&apos;);
        assert.equal(widget.calendar.currentYear, 2031, &apos;Should set correct year&apos;);

        clickElem(&apos;refs.suffix[0]&apos;);

        setTimeout(() =&gt; {
          checkCalendarState(true);
          clickElem(&apos;refs.suffix[0]&apos;);

          setTimeout(() =&gt; {
            checkCalendarState(false);
            document.body.innerHTML = &apos;&apos;;
            done();
          }, 300);
        }, 300);
      }, 300);
    }).catch(done);
  });

  it(&apos;Should allow manual input and set value on blur if calendar widget is enabled with allowed input&apos;, (done) =&gt; {
    const form = _.cloneDeep(comp6);
    form.components[0].widget = {
      allowInput: true,
      altInput: true,
      clickOpens: true,
      dateFormat: &apos;dd-MM-yyyy&apos;,
      enableDate: true,
      enableTime: true,
      format: &apos;dd-MM-yyyy&apos;,
      hourIncrement: 1,
      minuteIncrement: 5,
      mode: &apos;single&apos;,
      noCalendar: false,
      saveAs: &apos;date&apos;,
     &apos;time_24hr&apos;: false,
      type: &apos;calendar&apos;,
      useLocaleSettings: false,
    };
    const element = document.createElement(&apos;div&apos;);

    Formio.createForm(element, form).then(form =&gt; {
      const component = form.getComponent(&apos;textField&apos;);
      const clickElem = (path, element) =&gt; {
        const elem = element || _.get(component, path);
        const clickEvent = new Event(&apos;click&apos;);
        elem.dispatchEvent(clickEvent);
      };
      const checkCalendarState = (open, selectedDay) =&gt; {
        const calendar = document.querySelector(&apos;.flatpickr-calendar&apos;);
        assert.equal(calendar.classList.contains(&apos;open&apos;), open, `${open ? &apos;Should open calendar&apos; : &apos;Should close calendar&apos;}`);
        if (selectedDay) {
          const day = calendar.querySelector(&apos;.flatpickr-day.selected&apos;).textContent;
          assert.equal(day, selectedDay, &apos;Should select correct day&apos;);
        }
      };

      const triggerDateInputEvent = (eventName, value) =&gt; {
        const dateInput = component.element.querySelector(&apos;.form-control.input&apos;);
        const event = new Event(eventName);
        if (eventName === &apos;input&apos;) {
          dateInput.value = value;
        }
        dateInput.dispatchEvent(event);
      };

      triggerDateInputEvent(&apos;focus&apos;);

       setTimeout(() =&gt; {
        const date = &apos;21-01-2001&apos;;
        checkCalendarState(true);
        triggerDateInputEvent(&apos;input&apos;, date);

        setTimeout(() =&gt; {
          checkCalendarState(true);
          triggerDateInputEvent(&apos;blur&apos;);

          setTimeout(() =&gt; {
            checkCalendarState(true, 21);

            assert.equal(component.getValue(), date, &apos;Should set text field value&apos;);
            const widget = component.element.querySelector(&apos;.flatpickr-input&apos;).widget;
            assert.equal(widget.calendar.input.value, date, &apos;Should set flatpickr value&apos;);
            assert.equal(widget.calendar.currentMonth, 0, &apos;Should set correct month&apos;);
            assert.equal(widget.calendar.currentYear, 2001, &apos;Should set correct year&apos;);

            clickElem(&apos;refs.suffix[0]&apos;);

            setTimeout(() =&gt; {
              checkCalendarState(false);
              assert.equal(component.getValue(), date, &apos;Should save text field value&apos;);

              document.body.innerHTML = &apos;&apos;;
              done();
            }, 300);
          }, 300);
        }, 300);
      }, 300);
    }).catch(done);
  });

  it(&apos;Should allow removing date value if calendar widget is enabled with allowed input&apos;, (done) =&gt; {
    const form = _.cloneDeep(comp6);
    form.components[0].widget = {
      allowInput: true,
      altInput: true,
      clickOpens: true,
      dateFormat: &apos;dd-MM-yyyy&apos;,
      enableDate: true,
      enableTime: true,
      format: &apos;dd-MM-yyyy&apos;,
      hourIncrement: 1,
      minuteIncrement: 5,
      mode: &apos;single&apos;,
      noCalendar: false,
      saveAs: &apos;date&apos;,
     &apos;time_24hr&apos;: false,
      type: &apos;calendar&apos;,
      useLocaleSettings: false,
    };
    const element = document.createElement(&apos;div&apos;);

    Formio.createForm(element, form).then(form =&gt; {
      const component = form.getComponent(&apos;textField&apos;);
      const clickElem = (path, element) =&gt; {
        const elem = element || _.get(component, path);
        const clickEvent = new Event(&apos;click&apos;);
        elem.dispatchEvent(clickEvent);
      };

      const checkCalendarState = (open, selectedDay, noSelectedDay) =&gt; {
        const calendar = document.querySelector(&apos;.flatpickr-calendar&apos;);
        assert.equal(calendar.classList.contains(&apos;open&apos;), open, `${open ? &apos;Should open calendar&apos; : &apos;Should close calendar&apos;}`);
        if (selectedDay) {
          const day = calendar.querySelector(&apos;.flatpickr-day.selected&apos;).textContent;
          assert.equal(day, selectedDay, &apos;Should select correct day&apos;);
        }
        if (noSelectedDay) {
          const day = calendar.querySelector(&apos;.flatpickr-day.selected&apos;);
          assert.equal(!!day, false, &apos;Should not contain selected day&apos;);
        }
      };

      const triggerDateInputEvent = (eventName, value) =&gt; {
        const dateInput = component.element.querySelector(&apos;.form-control.input&apos;);
        const event = new Event(eventName);
        if (eventName === &apos;input&apos;) {
          dateInput.value = value;
        }
        dateInput.dispatchEvent(event);
      };

      let date = &apos;12-03-2009&apos;;
      component.setValue(date);
      triggerDateInputEvent(&apos;focus&apos;);

       setTimeout(() =&gt; {
        assert.equal(component.getValue(), date, &apos;Should set text field value&apos;);
        date = &apos;&apos;;
        checkCalendarState(true);
        triggerDateInputEvent(&apos;input&apos;, date);

        setTimeout(() =&gt; {
          checkCalendarState(true);
          triggerDateInputEvent(&apos;blur&apos;);

          setTimeout(() =&gt; {
            checkCalendarState(true, &apos;&apos;, true);

            assert.equal(component.getValue(), date, &apos;Should set text field value&apos;);
            const widget = component.element.querySelector(&apos;.flatpickr-input&apos;).widget;
            assert.equal(widget.calendar.input.value, date, &apos;Should set flatpickr value&apos;);

            clickElem(&apos;refs.suffix[0]&apos;);

            setTimeout(() =&gt; {
              checkCalendarState(false);
              assert.equal(component.getValue(), date, &apos;Should save text field value&apos;);
              document.body.innerHTML = &apos;&apos;;
              done();
            }, 300);
          }, 300);
        }, 300);
      }, 300);
    }).catch(done);
  });
});
</code></pre>

</div>

<footer class="footer">
  Generated by <a href="https://esdoc.org">ESDoc<span data-ice="esdocVersion">(1.1.0)</span><img src="./image/esdoc-logo-mini-black.png"></a>
</footer>

<script src="script/search_index.js"></script>
<script src="script/search.js"></script>
<script src="script/pretty-print.js"></script>
<script src="script/inherited-summary.js"></script>
<script src="script/test-summary.js"></script>
<script src="script/inner-link.js"></script>
<script src="script/patch-for-local.js"></script>
</body>
</html>
